/*	iconexec.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"

/*
ER}hiL̂̂Ƃ͊SɓƗj
%up			J[\Abv
%down		J[\_E
%mark		J[\}[N
%iexec		J[\ʒus
%copy		Rs[
%move		[u
%delete		f[g
%rename		l[
%mkdir		VKfBNg
%time		^CX^v
%attribute	Agr[g
%size		t@CTCY
%allmark	S}[N
%clear		}[N
%rversemark	}[N]
%filemark	t@Ĉ݃}[N
%rfresh		tbV
%eject fd	CWFNg fd= 1,2,3
%nop		Ȃ
%wsize x y	EBhETCYw
%sort mode	set sort mode( mode='default' or 0..6 )
%wild mask	set file mask( mask='input' or pattern )
%cd dir mask sort	change directory
%scroll x y	EBhEXN[܂
%scroll pup	y[WAbv(J[\Ǐ])
%scroll pdown	y[W_E(J[\Ǐ])
%dattrib b1 b2	fBNg\̃Agr[gw
%automove n	auto move n:0 off n:1 yesno n:2 input n:3 both
%askmode on/off	mF_CAO on/off
%linkmode n	N[h
%font n		tHgTCY
%wcolor n	EBhEJ[
%error on/off	G[[h
%wbank on/off	EBhETCYwKAȂ
%extmark ???	gq}[N
%extmark input	gq̓}[N
%where console	t@CR\[o
%where exec com	t@C}[NɃR}hs
%verbose on/off	R}hso߂̕\

*/

#define		LINEMAX		(1024*2)

unsigned char *
ptrskipchar( ptr )
unsigned char	*ptr;
{
	for(; *ptr && *ptr != '\n' && *ptr != ';' && *ptr != ' ' && *ptr != '\t' ; ptr++ );
	return	ptr;
}

unsigned char *
ptrskipspace( ptr )
unsigned char	*ptr;
{
	for(; *ptr == ' ' || *ptr == '\t' ; ptr++ );
	return	ptr;
}

unsigned char *
searchword( ptr )
unsigned char	*ptr;
{
	ptr= ptrskipchar( ptr );
	return	ptrskipspace( ptr );
}

void
cursormove( cp, pos )
ClientPack	*cp;
int	pos;
{
	short		i= 2,
				font_y= cp->font_y;
	LineFile	**ptr;
	DrawBuf		dbuf[2],
				*dp= dbuf;
	int	attr;

	ptr= cp->line + cp->cursor;
	attr= XFCOLOR;
	while( --i >= 0 ){
		if( !( (*ptr)->attr & 8 ) )	attr^= 8;
		DrawSetSymbol( dp++, FNAMEX, FNAMEY + cp->cursor * font_y,
					(char*)(*ptr)->str, attr, font_y );
		attr= XFCOLOR | AttrUnderLine;
		cp->cursor= pos;
		ptr= cp->line + pos;
	}
	WindowDraw( cp->swp, dbuf, dp-dbuf );
}


unsigned char *
innercommand( cp, n, ptr )
ClientPack	*cp;
int		n;
unsigned char	*ptr;
{
	switch( *ptr * 256 + ptr[1] ){
	case 'up': /* Cursor up */
		if( cp->cursor > 0 ){
			int	pos= cp->cursor - 1;
			cursormove( cp, pos );
			if( pos < HS_WindowGetHomeY( cp->swp ) / cp->font_y ){
				WindowScroll( cp->swp, 0, -cp->font_y );
			}
		}
		break;
	case 'ie': /* Icon exec */
		if( cp->cursor >= 0 )
			iexe( NULL, cp, cp->cursor );
		goto	downward;
	case 'ma': /* Cursor mark */
		if( cp->cursor >= 0 ){
			markdraw( cp, cp->cursor );
			cp->line[cp->cursor]->attr ^= 8;
		}
	case 'do': /* Cursor down */
downward:
		if( cp->cursor >= 0 && cp->cursor < cp->maxline - 1 ){
			int	pos= cp->cursor + 1;
			cursormove( cp, pos );
			if( pos >= ( HS_WindowGetHomeY( cp->swp )
						+ HS_WindowGetViewSizeY( cp->swp ) ) / cp->font_y ){
				WindowScroll( cp->swp, 0, cp->font_y );
			}
		}
		break;
	case 'co': /*Copy*/
		file_copy( cp, n );
		break;
	case 'mo': /*Move*/
		file_move( cp, n );
		break;
	case 'de': /*Delete*/
		file_delete( cp, n );
		break;
	case 're': /*Rename*/
		file_rename( cp, n );
		break;
	case 'mk': /*New dir*/
		file_mkdir( cp );
		break;
	case 'ti': /*Time stamp*/
		file_time( cp, n );
		break;
	case 'at': /*Attribute*/
		file_attr( cp, n );
		break;
	case 'si': /*File Size*/
		file_size( cp, n );
		break;
	case 'al': /*Set all mark*/
		markclear( cp, 0 );
		break;
	case 'cl': /*Erase all mark*/
		markclear( cp, 8 );
		break;
	case 'rv': /*reVerse mark*/
		reversemark( cp );
		break;
	case 'fi':
		filemark( cp );
		break;
	case 'rf':
		resetposition( cp, TRUE );
		break;
	case 'ej':
		ptr= searchword( ptr+2 );
		disk_eject( atoi2(ptr) );
		break;
	case 'no':
		break;
	case 'ws':
		ptr= ptrskipchar( ptr+2 );
		if( *ptr && *ptr != '\n' ){
			short	xsize,
				ysize= 0;
			ptr= ptrskipspace( ptr );
			xsize= atoi2( ptr );
			if( *ptr ){
				ptr= searchword( ptr );
				ysize= atoi2( ptr );
			}
			if( xsize == 0 )
				xsize= HS_WindowGetViewSizeX( cp->bwp );
			if( ysize == 0 )
				ysize= HS_WindowGetViewSizeY( cp->bwp );
			windowresize( cp, -1, -1, xsize, ysize );
		}
		break;
	case 'so':
		{
			short	i;
			ptr= searchword( ptr+2 );
			if( *ptr == 'd' )
				i= cp->defsort;
			else
				i= atoi2(ptr);
			if( i >= 0 && i < 7 ){
				cp->sortmode= i;
				resetposition( cp, TRUE );
			}
		}
		break;
	case 'wi':
		{
			unsigned char	buf[30],
					*str= buf;
			ptr= searchword( ptr+2 );
			for(; *ptr && *ptr != '\n' && *ptr != ' ' ;)
				*str++= *ptr++;
			*str=
			buf[7]= '\0';
			if( strcmp( buf, "input" ) )
				strcpy( cp->mask, buf );
			else{
				*ibuf= '\0';
				if( !Dialog( cp, "ChJ[h̐ݒ",
				"͂ĉB(ő7)", dialogINPUT ) )
					break;
				if( !*ibuf )
					break;
				ibuf[7]= '\0';
				strcpy( cp->mask, ibuf );
			}
			resetposition( cp, FALSE );
		}
		break;
	case 'cd':
		{
			unsigned char	buf[PATHMAX],
					buf2[PATHMAX],
					*str= buf;
			int		sort= cp->sortmode;
			ptr= searchword( ptr+2 );
			for(; *ptr && *ptr != '\n' && *ptr != ' ' ;)
				*str++= *ptr++;
			*str= '\0';
			strcpy( buf2, "*.*" );
			ptr= searchword( ptr );
			if( *ptr && *ptr != '\n' ){
				str= buf2;
				for(; *ptr && *ptr != '\n' && *ptr != ' ' ;)
					*str++= *ptr++;
				*str= '\0';
				buf2[7]= '\0';
				ptr= searchword( ptr );
				if( *ptr && *ptr != '\n' ){
					sort= atoi2( ptr );
				}
			}
			changedir( cp, buf, buf2, sort );
		}
		break;
	case 'sc':
		{
			int	x= 0,
				y= 0,
				i= 0;
			ptr= searchword( ptr+2 );
			if( *ptr != 'p' ){
				x= atoi2( ptr );
				ptr= searchword( ptr );
				y= atoi2( ptr );
			}else{
				y= HS_WindowGetViewSizeY( cp->swp );
				i= y / cp->font_y;
				if( i )	i--;
				if( y>16 ){
					y-= 12;
				}
				if( ptr[1] == 'd' ){
					i= -i;
					y= -y;
				}
			}
			if( i && cp->cursor >= 0 ){
				i+= cp->cursor;
				if( i < 0 ){
					i= 0;
				}else if( i >= cp->maxline ){
					i= cp->maxline - 1;
				}
				cursormove( cp, i );
			}
			WindowScroll( cp->swp, x, y );
		}
		break;
	case 'da':
		ptr= searchword( ptr+2 );
		cp->byte1= atoi2( ptr );
		ptr= searchword( ptr );
		cp->byte2= atoi2( ptr );
		resetposition( cp, FALSE );
		break;
	case 'au':	/* auto move */
		ptr= searchword( ptr+2 );
		cp->automove= atoi2( ptr );
		break;
	case 'as':	/* ask mode */
		ptr= searchword( ptr+2 );
		cp->askmode= ptr[1] == 'n';
		break;
	case 'li':
		ptr= searchword( ptr+2 );
		{extern short linkdisp;
		linkdisp= atoi2( ptr );}
		resetposition( cp, TRUE );
		break;
	case 'fo':
		ptr= searchword( ptr+2 );
		cp->font_y= atoi2( ptr );
		resetposition( cp, FALSE );
		break;
	case 'wc':
		ptr= searchword( ptr+2 );
		{extern F_G_Color, B_G_Color;
		F_G_Color= atoi2( ptr );
		B_G_Color= (F_G_Color&8) ? F_G_Color&3 : 0;
		WindowRedraw( cp->swp );
		}
		break;
	case 'er':	/* ask mode */
		ptr= searchword( ptr+2 );
		{extern short errormode;
		errormode= ptr[1] == 'n';}
		break;
	case 'wb':
		ptr= searchword( ptr+2 );
		{extern short windowbank;
		windowbank= ptr[1] == 'n';}
		break;
	case 'ex':
		{
			unsigned char	buf[30],
					*str= buf;
			ptr= searchword( ptr+2 );
			for(; *ptr && *ptr != '\n' && *ptr != ' ' ;)
				*str++= *ptr++;
			*str=
			buf[7]= '\0';
			if( strcmp( buf, "input" ) )
				extmark( cp, buf );
			else{
				*ibuf= '\0';
				if( !Dialog( cp, "gqɂ}[Nݒ",
				"gq͂ĉ",
								dialogINPUT ))
					break;
				if( !*ibuf )
					break;
				ibuf[7]= '\0';
				extmark( cp, *ibuf == '.' ? ibuf+1 :
					( *ibuf == '*' ? ibuf+2 : ibuf ) );
			}
		}
		break;
	case 'wh':
		{
			extern short	findmode;
			unsigned char	*mes=(void*)"t@C: Consoleo";
			ptr= searchword( ptr+2 );
			if( *ptr == 'c' ){
				findmode= 0;	/* Console */
			}else if( *ptr == 'm' ){
				findmode= 1;	/* MOVE */
				mes= (void*)"t@C: ިڸ؈ړ";
			}
			*ibuf= '\0';
			if( !Dialog( cp, mes,
			"t@CH(ChJ[hgp)",
							dialogINPUT ))
				break;
		}
		if( !*ibuf )
			break;
		file_find( cp, ibuf );
		break;
	case 've':
		{
			extern short	dispmode;
			ptr= searchword( ptr+2 );
			dispmode= ptr[1] == 'n';
		}
		break;
	case 'pa':
		{
			unsigned char	*ptr= cp->path;
			while( *ptr )	ptr++;
			ptr-= 2;
			if( *ptr != ':' ){
				while( *ptr != '/' && *ptr != '\\' )	ptr--;
				*(ptr + 1)= '\0';
				chgposition( cp );
			}
		}
		break;
	default:
		conserr( NULL, "`R}h" );
	}
	for(; *ptr && *ptr != '\n' && *ptr != ';' ; ptr++ );
	if( *ptr == ';' )
		return	ptr;
	return	NULL;
}
