/*	keyexec.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"

/*
	bit 0..7	keycode
	bit 8		SHIFT		S
	bit 9		CTRL		C
	bit 10		OPT.1		O1
	bit 11		OPT.2		O2
	bit 12		XF1		X1
	bit 13		XF2		X2
	bit 14		XF3		X3
	bit 15		FUNCKEY		F

SCX1X2X3-
	"X1-a,#FileMenu,0"
O1-
*/
#define		KEYMAX	60

typedef struct {
	unsigned short	keycode;
	unsigned char	*execptr;
} KeyTable;

static short	tablemax= 0;
KeyTable	KeyP[ KEYMAX ];

#define	kSHIFT	(1<<8)
#define	kCTRL	(1<<9)
#define	kOPT1	(1<<10)
#define	kOPT2	(1<<11)
#define	kXF1	(1<<12)
#define	kXF2	(1<<13)
#define	kXF3	(1<<14)
#define	kFNC	(1<<15)

initkeytable()
{
	unsigned char	*ptr= WindowGetResource("String","KeyTable",PRGNAME_R);
	KeyTable	*p= KeyP;
	if( !ptr )
		return;
	for(; *ptr ;){
		unsigned short	key,
				code;
		unsigned char	buf[20],
				*str,
				*rs;
	loopcontinue:
		for( code= 0 ; *ptr != '-' && *ptr != ',' ; ptr++ ){
			key= *ptr;
			switch( *ptr ){
			case '\0':
				return;
			case '\n':
				ptr++;
				goto	loopcontinue;
			case 's':
			case 'S':
				code|= kSHIFT;
				break;
			case 'c':
			case 'C':
				code|= kCTRL;
				break;
			case 'o':
			case 'O':
				code|= (ptr[1] == '1' ? kOPT1 : kOPT2);
				ptr++;
				break;
			case 'x':
			case 'X':
				code|= (ptr[1] == '1' ? kXF1 :
					(ptr[1] == '2' ? kXF2 : kXF3 ));
				ptr++;
				break;
			case 'f':
			case 'F':
				code|= kFNC;
			}
		}
		p->keycode= *ptr == '-' ? (code|(ptr[1] & 0xff)) : key;
		while( *ptr && *ptr != ',' && *ptr != '\n' )
			ptr++;
		if( *ptr != ',' )
			return;
		ptr++;
		if( *ptr != '#' ){
			if( *ptr == 'Y' ){
				p->execptr= (void*)1;
			}else if( *ptr == 'N' ){
				p->execptr= (void*)2;
			}else if( *ptr == 'G' ){
				p->execptr= (void*)3;
			}else
				return;
			p++;
			tablemax++;
			while( *ptr && *ptr != '\n' )
				ptr++;
			continue;
		}
		str= buf;
		for( ptr++ ; *ptr && *ptr != ',' ; *str++= *ptr++ );
		*str= '\0';
		key= 0;
		if( *ptr == ',' )
			key= atoi2( ptr+1 );
		while( *ptr && *ptr != '\n' )
			ptr++;
		rs= WindowGetResource( "String", (char*)buf, PRGNAME_R );
		if( !rs )
			continue;
		if( key == 0 ){
			p->execptr= rs;
			p++;
			tablemax++;
		}else for( code= 0 ; *rs ; rs++ ){
			if( *rs == '\n' ){
				code++;
				if( code == key ){
					p->execptr= rs+1;
					p++;
					tablemax++;
					break;
				}
			}
		}
	}
}

keyexec( cp, info, flag )
ClientPack	*cp;
EventInfo	*info;
int		flag;
{
	unsigned short	code= info->KeyCode & 0xff;
	KeyTable	*p= KeyP;
	short		i;
	if( code >= 'A' && code <= 'Z' ){
		info->ShiftStat |= 1;
	}else if( code >= 'a' && code <= 'z' )
		code-= 0x20;
	if( code < ' ' ){
		code+= '@';
		if( info->KeyCode < 256 )
			info->ShiftStat |= 2;
	}
	code+= (info->ShiftStat & 0x0f) << 8;
	code+= (BITSNS(10) & 0xe0) << 7;
	code+= info->KeyCode & 0x8000;
	for( i= 0 ; i< tablemax ; i++, p++ ){
		if( code == p->keycode ){
			if( flag && (int)p->execptr > 16 )
				iconexec( cp, -1, p->execptr );
			return	(int)p->execptr;
		}
	}
}

