/*	scrollexec.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"

#define		mOFF	0
#define		mNORMAL	1
#define		mREGION	2
#define		mSEND	3

#define		PAT_NORMAL	0
#define		PAT_FILE	1
#define		PAT_MARKING	2

extern short	dmode;

void
leftoffcheck( info )
EventInfo	*info;
{
	while( !(WindowGetEventInfo(info) && info->LeftOFF) );
}

void
markdraw( cp, i )
ClientPack	*cp;
int		i;
{
	DrawBuf	dbuf[1];
	DrawSetLine( dbuf, FNAMEX, i*cp->font_y, (MAXFILESTR/2)*cp->font_y+
		FNAMEX, (i+1)*cp->font_y-1, XRCOLOR|OptionXor, OptionFill );
	WindowDraw( cp->swp, dbuf, 1 );
}
void
markclear( cp, mark )
ClientPack	*cp;
int		mark;
{
	short	i;
	for( i= 0 ; i< cp->maxline ; i++ ){
		if( ( cp->line[i]->attr & 8 ) != mark ){
			markdraw( cp, i );
			cp->line[i]->attr ^= 8;
		}
	}
}

void
reversemark( cp )
ClientPack	*cp;
{
	short	i;
	for( i= 0 ; i< cp->maxline ; i++ ){
		markdraw( cp, i );
		cp->line[i]->attr ^= 8;
	}
}

void
filemark( cp )
ClientPack	*cp;
{
	short	i;
	for( i= 0 ; i< cp->maxline ; i++ ){
		if( cp->line[i]->str[50] == 'A' ){
			markdraw( cp, i );
			cp->line[i]->attr ^= 8;
		}
	}
}

void
iexe( info, cp, i )
EventInfo	*info;
ClientPack	*cp;
short	i;
{
	unsigned char	*ptr= cp->line[i]->str;
	if( cp->line[i]->icon == iLINK ){ /* link */
		/*ptr[23] == 'l'*/
		unsigned char	buf[PATHMAX];
		getfpath( cp, buf, i );
		if( CHDIR( buf ) >= 0 )
			goto	chdir;
		CHDIR( cp->path );
	}else if( cp->line[i]->icon == iDIR ){ /*dir*/
		/*ptr[51] == 'D'*/
	chdir:
		bankin( cp );
	for(; *ptr != ' ' ; ptr++ );
		*ptr++= '\\';
		*ptr= '\0';
		strcat( cp->path, cp->line[i]->str );
		chgposition( cp );
		if( info )	leftoffcheck( info );
	}else if( !dmode && cp->line[i]->icon )
		iconexec( cp, i, IconP[cp->line[i]->icon-1].execptr[0] );
}

ScrollExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	ClientPack	*cp;
	if( info->option == EventOpen )
		return	TRUE;
	cp= (ClientPack*)HS_WindowGetClientPointer(wp);
	switch( info->option ){
	case EventRedraw:
		{
			short		y,
					yy,
					i,
					font_y= cp->font_y;
			LineFile	**ptr;
			DrawBuf		dbuf[96/*85*//*DBUFSIZE*2*/],
					*dp= dbuf;
			DrawSetClear( dp++, XBACKCOLOR );
			y= HS_WindowGetHomeY(wp)/font_y;
			yy= HS_WindowGetViewSizeY(wp)/font_y;
			if( cp->cursor < y || cp->cursor >= y + yy ){
				if( HS_WindowGetHomeY(wp) % font_y > 3 ){
					cp->cursor= y+1;
				}else {
					cp->cursor= y;
				}
			}
			if( y )	y--;
			i= y;
			ptr= cp->line+i;
			y*= font_y;
			yy=HS_WindowGetViewSizeY(wp)+ y+font_y+font_y;
			for(; y<yy && i<cp->maxline ; y+=font_y, i++, ptr++ ){
				int	attr;
				attr= (*ptr)->attr & 8 ? XFCOLOR : XFCOLOR^8;
				if( i == cp->cursor )	attr|= AttrUnderLine;
				DrawSetSymbol( dp++, FNAMEX, FNAMEY+y,
					(char*)(*ptr)->str, attr, font_y );
				if( (*ptr)->icon )
					DrawSetPut( dp++, 0, FNAMEY+y, IconP[(*ptr)->icon-1].pat );
			}
			WindowDraw( wp, dbuf, dp-dbuf );
		}
		return	TRUE;
	case EventMouseSwitch: {
		short	i= info->y/cp->font_y;
		if( i < 0 )
			return	TRUE;
		if( i >= cp->maxline ){
			if( info->RightON )
				iconmenu( cp, i, UtilP[2].execptr, UtilP[2].iconn, FALSE );
			return	TRUE;
		}
		if( (B_SFTSNS()&(4+2)) && info->LeftON ){	/* OPT.1 */
			SetClipBoard( wp, info, (unsigned char**)cp->line,
					cp->maxline, FALSE, cp->font_y );
		}else if( info->x<FNAMEX ){
			if( info->LeftON ){
				iexe( info, cp, i );
			}else if( info->RightON && cp->line[i]->icon == iDIR ){
				UtilPack	up;
				if( makemenu( "SysDir", &up ) )
					iconmenu( cp, i, up.execptr, up.iconn,
						FALSE );
			}else if(!dmode && info->RightON && cp->line[i]->icon){
				iconmenu( cp, i,
					IconP[cp->line[i]->icon-1].execptr,
					IconP[cp->line[i]->icon-1].iconn-1,
					FALSE );
			}
		}else if( !dmode &&  info->LeftON ){
			short	mark= (cp->line[i]->attr&8)^8,
				mode= mOFF;
			int	x, y;
			WindowGetScreenPosition( wp, &x, &y );
			setmspattern();
		retry:
			if( (cp->line[i]->attr & 8) != mark ){
				markdraw( cp, i );
				cp->line[i]->attr ^= 8;
			}
			for( ;; ){
				WindowGetEventInfo(info);
				if( info->LeftOFF )
					break;
			region:
				if( info->RightStat ){
					short	j= i;
					if( mode != mREGION )
						MS_SEL( PAT_MARKING );
					mode= mREGION;
					if( !info->MoveFlag )
						continue;
					info->y -= y;
					if( info->y < 0 || info->y >= HS_WindowGetViewSizeY(wp) )
						continue;
					i= (info->y+HS_WindowGetHomeY(wp))/cp->font_y;
					if( j != i && i>=0 && i<cp->maxline )
						goto	retry;
				}else if( mode == mREGION ){
					MS_SEL( PAT_NORMAL );
					mode= mNORMAL;
				}else if( !mark && mode == mOFF && info->MoveFlag ){
					WindowID	cwp;
					MS_SEL( PAT_FILE );
					while( !(WindowGetEventInfo(info) && info->LeftOFF ) ){
						info->y -= y;
						info->x -= x;
						if( info->RightStat && info->y >=0 &&
							info->y < HS_WindowGetViewSizeY(wp) &&
							info->x >=0 &&
							info->x < HS_WindowGetViewSizeX(wp) )
							goto	region;
					}
					cwp= WindowGetChild( WindowRootID, info );
					if( cwp == wp || cwp == cp->bwp )
						break;
					sendname( cp, cwp, info );
					markclear( cp, 8 );
					break;
				}
			}
			MS_SEL( PAT_NORMAL );
		}else if( !dmode && info->RightON ){
			if( info->x < (24/2)*cp->font_y+FNAMEX )
			   iconmenu( cp, i, UtilP[0].execptr, UtilP[0].iconn, FALSE );
			else
			   iconmenu( cp, i, UtilP[1].execptr, UtilP[1].iconn, FALSE );
		}
#if 0
 info->x < (24/2)*cp->font_y+FNAMEX )/*file*/
 info->x < (31/2)*cp->font_y+FNAMEX )/*size*/
 info->x < (40/2)*cp->font_y+FNAMEX )/*date*/
 info->x < (49/2)*cp->font_y+FNAMEX )/*attr*/
#endif
		return	TRUE;
		}
	case EventClose:
		WindowClose( wp );
		return	TRUE;
	}
	return	FALSE;
}
